//+------------------------------------------------------------------+
//|                                           Chande Momentum        |
//+------------------------------------------------------------------+

//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 20
#property  indicator_color1  Red
#property  indicator_width1  2

      
extern int CMO_Period = 15;

//---- buffers


double cmo1[];
double scmo1[];
double cmo2[];
double scmo2[];
double cmo[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
//---- drawing settings
   
   SetIndexStyle(0,DRAW_LINE);


  // IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);





//cmo dif1	cmo1	scmo1	cmo2	scmo2	cmo3	cmo4

//---- 3 indicator buffers mapping



   SetIndexBuffer(0,cmo);

//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("CMO("+CMO_Period+")");
   
   
   ArrayResize(cmo1,Bars);
   ArraySetAsSeries(cmo1,true);
 
   ArrayResize(scmo1,Bars);
   ArraySetAsSeries(scmo1,true);
 
   ArrayResize(cmo2,Bars);
   ArraySetAsSeries(cmo2,true);
 
   ArrayResize(scmo2,Bars);
   ArraySetAsSeries(scmo2,true);  
   
//---- initialization done
   return(0);
  }

int start()
{
   int i, j, k, limit;
   double dif1, cmo3, cmo4, Tcmo1, Tscmo1, Tcmo2, Tscmo2;
   int    counted_bars=IndicatorCounted();
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
  

   for(i = limit; i >= 0; i--)
     {
       dif1 = Close[i]-Close[i+1];
       if(dif1>=0) 
         Tcmo1 = dif1;
       else 
         Tcmo1 = 0;
       cmo1[i] = Tcmo1;
       if(dif1>=0) 
         Tcmo2 = 0;
       else 
         Tcmo2 = -dif1;
       cmo2[i] = Tcmo2;
     }

 
   for(i = limit; i >= 0; i--)
     {
       Tscmo1 = 0;
       for(j = i + CMO_Period-1; j >= i; j--)
         Tscmo1 += cmo1[j];
       scmo1[i] = Tscmo1;
     }

 
   for(i = limit; i >= 0; i--)
     {
       Tscmo2 = 0;
       for(j = i + CMO_Period-1; j >= i; j--)
         Tscmo2 += cmo2[j];
       scmo2[i] = Tscmo2;
     }

//int logCMO=FileOpen(Symbol()+"CMO.csv",FILE_CSV|FILE_WRITE, ';');
//FileWrite(logCMO, "Time[i]", "Close[i]", "Close[i+1]", "Close[i]-Close[i+1]", "cmo1[i]", "scmo1[i]", "cmo2[i]", "scmo2[i]", "cmo3");       
   for(i = limit; i >= 0; i--)
     {
       cmo3 = scmo1[i]-scmo2[i];
       cmo4 = scmo1[i]+scmo2[i];
       if(cmo4 == 0)cmo4=0.0001;
         cmo[i] = (cmo3/cmo4) *100 ;


//       FileWrite(logCMO, Time[i], Close[i], Close[i+1], Close[i]-Close[i+1], cmo1[i], scmo1[i], cmo2[i], scmo2[i], cmo3, cmo4);       
     }

// FileClose(logCMO);
      
      return(0);
  }
//+------------------------------------------------------------------+



